

/*
  ͸
       Programmed by Steve Downie      May 13, 1987             
                                                                
       Program: Timer2.c                                        
                                                                
       Notes:   Timer2.exe gives you the execution time of      
                other .exe and .com files. It is useful for     
                comparing different versions of a program in    
                order to determine differences in execution     
                speed. It is designed to also accept additional 
                command line parameters following the filename. 
                                                                
       Useage:  Timer2 [filename] [parameters]                  
                                                                
       CIS ID#: 74716,521                                       
                                                                
  ;
*/

#include "stdio.h"
#include "dos.h"
#include <string.h>                 /* declares getenv()      */
#define MAXCH 128
#define SP " "

                  
#define  T_PER_S  (18.2065)         /* ticks per second       */
#define  INT_TIME 0x1A              /* The interrupt number   */

long     t_counts() ;               /* Returns tick count     */

main(argc, argv)  
int   argc   ;
char *argv[] ;
{
  char cmdstr[MAXCH];
  long ts, te  ;
  int i = 1;

  if( argc < 2 )
      {                            /* Print if no command line program given */
       ++argv;
     printf("[1mTimer2.exe programmed by Steve Downie  CIS 74716,521[0m\n\n");
     printf("\n\n[7m USAGE: [0m timer2 [filename] \n\n") ;
     printf("Timer2.exe will give you the execution time of any .com or ");
     printf(".exe program.\n");
     printf("It can be called with multiple command line arguments, or by ");
     printf("supplying a\n");
     printf("filename at the following prompt ****************************");
     printf("***********\n\n");
     printf("Enter filename you wish to time: ") ;
     scanf("%s", argv[1] ) ;
      }
   strcpy(cmdstr,argv[i++]);
   while( i <= argc)
         {
          strncat(cmdstr,SP,MAXCH - 1);
          strncat(cmdstr,argv[i++],MAXCH - 1);
         }
   ts = t_counts() ;                  /* Start tick count */
   system(cmdstr);                    /* RUN COMMAND */
   te = t_counts() ;                  /* End tick count   */
   printf("\n\n[7m Total run time for ");
  printf("%s was: [5;7m%0.4f[0;7m seconds [0m\n\n",argv[1],(te-ts)/T_PER_S);
                                      /* Total elapsed time */
} 

long t_counts()                       /* Function t_counts() */
{
union REGS rin, rout ;                /* REGS input, output register values  */
long tc ;                             /* as defined in dos.h */
 

rin.h.ah = 0 ;                        /* Choose read clock mode */
int86(INT_TIME, &rin, &rout) ;
tc = ( (long) rout.x.cx ) << 16 ;     /* High bytes */
tc += rout.x.dx ;                     /* Add low bytes */

return tc ;
}

